-- Midnight Reveries Naxxramas Boss Mods v7.23 - 21/09/2006
-- Fixed oldcharge bug in Thaddius.

-- Loading Modules
tinsert(CT_RABoss_ModsToLoad, "CT_RABoss_MRPatchwerk_OnLoad");
tinsert(CT_RABoss_ModsToLoad, "CT_RABoss_MRGrobbulus_OnLoad");
tinsert(CT_RABoss_ModsToLoad, "CT_RABoss_MRGluth_OnLoad");
tinsert(CT_RABoss_ModsToLoad, "CT_RABoss_MRThaddius_OnLoad");


-- Patchwerk - (19/08/2006) - Changed naming.
function CT_RABoss_MRPatchwerk_OnLoad()
	CT_RABoss_AddMod("Abomination wing: Patchwerk", CT_RABOSS_MRPATCHWERK_INFO, 1, CT_RABOSS_LOCATIONS_MRNAXXRAMAS);
	CT_RABoss_AddEvent("Abomination wing: Patchwerk", "CHAT_MSG_MONSTER_YELL", CT_RABoss_MRPatchwerk_EventHandler);
	CT_RABoss_AddEvent("Abomination wing: Patchwerk", "CHAT_MSG_MONSTER_EMOTE", CT_RABoss_MRPatchwerk_EventHandler);
	CT_RABoss_AddEvent("Abomination wing: Patchwerk", "CHAT_MSG_COMBAT_CREATURE_VS_CREATURE_HITS", CT_RABoss_MRPatchwerk_EventHandler);
	CT_RABoss_AddEvent("Abomination wing: Patchwerk", "CHAT_MSG_COMBAT_CREATURE_VS_PARTY_HITS", CT_RABoss_MRPatchwerk_EventHandler);
	CT_RABoss_AddEvent("Abomination wing: Patchwerk", "CHAT_MSG_COMBAT_CREATURE_VS_SELF_HITS", CT_RABoss_MRPatchwerk_EventHandler);

	CT_RABoss_AddDropDownButton("Abomination wing: Patchwerk", { CT_RABOSS_ANNOUNCE, CT_RABOSS_ANNOUNCE_INFO .. CT_RABOSS_REQ_LEADER_OR_PROM }, "CT_RABoss_ModInfo", "announce", "CT_RABoss_SetInfo");
end

function CT_RABoss_MRPatchwerk_EventHandler(event)
	if ( not CT_RABoss_Mods["Abomination wing: Patchwerk"] or not CT_RABoss_Mods["Abomination wing: Patchwerk"]["status"] or not CT_RABoss_Mods["Abomination wing: Patchwerk"].enabled ) then
		return;
	end

	if ( event == "CHAT_MSG_MONSTER_YELL" ) then
		if ( arg1 == CT_RABOSS_MRPATCHWERK_YELL1 or arg1 == CT_RABOSS_MRPATCHWERK_YELL2 ) then
			CT_RABoss_Announce(CT_RABOSS_MRPATCHWERK_ENGAGED, CT_RABoss_Mods["Abomination wing: Patchwerk"]["announce"]);
			CT_RABoss_PlaySound(3);
			CT_RABoss_Schedule("CT_RABoss_MRPatchwerk_EventHandler", 30, "enragetimer");
			CT_RABoss_Mods["Abomination wing: Patchwerk"]["enrageleft"] = 6.5;
			CT_RABoss_Mods["Abomination wing: Patchwerk"]["lastaction"] = time();

		elseif ( arg1 == CT_RABOSS_MRPATCHWERK_DEAD ) then
			CT_RABoss_UnSchedule("CT_RABoss_MRPatchwerk_EventHandler");
		end
	
	elseif ( event == "enragetimer") then
		if ( not CT_RABoss_Mods["Abomination wing: Patchwerk"]["lastaction"] or ( time() - CT_RABoss_Mods["Abomination wing: Patchwerk"]["lastaction"] ) > 30 ) then
			return;

		elseif ( CT_RABoss_Mods["Abomination wing: Patchwerk"]["enrageleft"] == 0.5 ) then
			CT_RABoss_Schedule("CT_RABoss_MRPatchwerk_EventHandler", 15, "enrage15");
			CT_RABoss_Schedule("CT_RABoss_MRPatchwerk_EventHandler", 25, "enrage5");
			CT_RABoss_Announce(format(CT_RABOSS_MRPATCHWERK_SECWARN, "30"), CT_RABoss_Mods["Abomination wing: Patchwerk"]["announce"]);
			CT_RABoss_PlaySound(3);
		else
			if ( CT_RABoss_Mods["Abomination wing: Patchwerk"]["enrageleft"] == 1 ) then
				CT_RABoss_Announce(CT_RABOSS_MRPATCHWERK_1MINWARN, CT_RABoss_Mods["Abomination wing: Patchwerk"]["announce"]);
			else
				CT_RABoss_Announce(format(CT_RABOSS_MRPATCHWERK_WARN, CT_RABoss_Mods["Abomination wing: Patchwerk"]["enrageleft"]), CT_RABoss_Mods["Abomination wing: Patchwerk"]["announce"]);
			end

			CT_RABoss_Mods["Abomination wing: Patchwerk"]["enrageleft"] = CT_RABoss_Mods["Abomination wing: Patchwerk"]["enrageleft"]-0.5;
			CT_RABoss_Schedule("CT_RABoss_MRPatchwerk_EventHandler", 30, "enragetimer");
			CT_RABoss_PlaySound(3);
		end

	elseif ( event == "CHAT_MSG_MONSTER_EMOTE" and arg2 == CT_RABOSS_MRPATCHWERK_BOSSNAME ) then
		if ( arg1 == CT_RABOSS_MRPATCHWERK_ENRAGESTRING ) then
			CT_RABoss_Announce(CT_RABOSS_MRPATCHWERK_ENRAGEWARNING, CT_RABoss_Mods["Abomination wing: Patchwerk"]["announce"]);
			CT_RABoss_PlaySound(2);
			CT_RABoss_Mods["Abomination wing: Patchwerk"]["lastaction"] = time();

		elseif ( arg1 == CT_RABOSS_MRPATCHWERK_BERSERKSTRING ) then
			CT_RABoss_Announce(CT_RABOSS_MRPATCHWERK_BERSERKWARNING, CT_RABoss_Mods["Abomination wing: Patchwerk"]["announce"]);
			CT_RABoss_PlaySound(1);
			CT_RABoss_UnSchedule("CT_RABoss_MRPatchwerk_EventHandler");
		end

	elseif ( event == "CHAT_MSG_COMBAT_CREATURE_VS_CREATURE_HITS" or event == "CHAT_MSG_COMBAT_CREATURE_VS_PARTY_HITS" or event == "CHAT_MSG_COMBAT_CREATURE_VS_SELF_HITS" ) then
		if ( string.find(arg1, CT_RABOSS_MRPATCHWERK_BOSSNAME) ) then
			CT_RABoss_Mods["Abomination wing: Patchwerk"]["lastaction"] = time();
		end	

	elseif ( event == "enrage15" ) then
		CT_RABoss_Announce(format(CT_RABOSS_MRPATCHWERK_SECWARN, "15"), CT_RABoss_Mods["Abomination wing: Patchwerk"]["announce"]);
		CT_RABoss_PlaySound(3);

	elseif ( event == "enrage5" ) then
		CT_RABoss_Announce(format(CT_RABOSS_MRPATCHWERK_SECWARN, "5"), CT_RABoss_Mods["Abomination wing: Patchwerk"]["announce"]);
		CT_RABoss_PlaySound(3);
	end
end


-- Grobbulus - (19/08/2006) - Changed naming.
function CT_RABoss_MRGrobbulus_OnLoad()
	CT_RABoss_AddMod("Abomination wing: Grobbulus", CT_RABOSS_MRGROBBULUS_INFO, 1, CT_RABOSS_LOCATIONS_MRNAXXRAMAS);
	CT_RABoss_AddEvent("Abomination wing: Grobbulus", "CHAT_MSG_SPELL_PERIODIC_FRIENDLYPLAYER_DAMAGE", CT_RABoss_MRGrobbulus_EventHandler);
	CT_RABoss_AddEvent("Abomination wing: Grobbulus", "CHAT_MSG_SPELL_PERIODIC_PARTY_DAMAGE", CT_RABoss_MRGrobbulus_EventHandler);
	CT_RABoss_AddEvent("Abomination wing: Grobbulus", "CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE", CT_RABoss_MRGrobbulus_EventHandler);

	CT_RABoss_AddDropDownButton("Abomination wing: Grobbulus", { CT_RABOSS_ANNOUNCE, CT_RABOSS_ANNOUNCE_INFO .. CT_RABOSS_REQ_LEADER_OR_PROM }, "CT_RABoss_ModInfo", "announce", "CT_RABoss_SetInfo");
	CT_RABoss_AddDropDownButton("Abomination wing: Grobbulus", { CT_RABOSS_MRGROBBULUS_ALERT, CT_RABOSS_MRGROBBULUS_ALERT_INFO }, "CT_RABoss_ModInfo", "alertnearby", "CT_RABoss_SetInfo");
	CT_RABoss_AddDropDownButton("Abomination wing: Grobbulus", { CT_RABOSS_MRGROBBULUS_TELL, CT_RABOSS_MRGROBBULUS_TELL_INFO }, "CT_RABoss_ModInfo", "sendtell", "CT_RABoss_SetInfo");
	
	CT_RABoss_SetVar("Abomination wing: Grobbulus", "alertnearby", 1);
	CT_RABoss_Mods["Abomination wing: Grobbulus"]["icons"] = {false,false,false,false,false,false,false,false};
end


function CT_RABoss_MRGrobbulus_EventHandler(event)
	if ( not CT_RABoss_Mods["Abomination wing: Grobbulus"] or not CT_RABoss_Mods["Abomination wing: Grobbulus"]["status"] or not CT_RABoss_Mods["Abomination wing: Grobbulus"].enabled ) then
		return;
	end

	if ( event == "CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE" or ( ( event == "CHAT_MSG_SPELL_PERIODIC_FRIENDLYPLAYER_DAMAGE" or event == "CHAT_MSG_SPELL_PERIODIC_PARTY_DAMAGE" ) and CT_RABoss_Mods["Abomination wing: Grobbulus"]["alertnearby"] ) ) then
		local _, _, playername, playertype = string.find(arg1, CT_RABOSS_MRGROBBULUS_MIEXP);
		if ( playername ) then
			if ( playertype == CT_RABOSS_MRNAME_TYPE_YOU and playername == CT_RABOSS_MRNAME_YOU ) then
				playername = UnitName("player");
				CT_RABoss_Announce(CT_RABOSS_MRGROBBULUS_AFFLICTED_YOU);
				CT_RABoss_Announce(CT_RABOSS_MRGROBBULUS_AFFLICTED_YOU);
				CT_RABoss_PlaySound(2);

				if ( CT_RA_Level >= 1 and CT_RABoss_Mods["Abomination wing: Grobbulus"]["announce"] ) then
					CT_RA_AddMessage("MS " .. format(CT_RABOSS_MRGROBBULUS_AFFLICTED, playername));
				end

			elseif ( CT_RABoss_Mods["Abomination wing: Grobbulus"]["alertnearby"] or CT_RABoss_Mods["Abomination wing: Grobbulus"]["sendtell"] ) then
				if ( CT_RABoss_Mods["Abomination wing: Grobbulus"]["sendtell"] ) then
					SendChatMessage(CT_RABOSS_MRGROBBULUS_AFFLICTED_YOU, CT_RABOSS_MRGROBBULUS_AFFLICTED_WHISPER, nil, playername);
				end

				if ( CT_RABoss_Mods["Abomination wing: Grobbulus"]["alertnearby"] ) then
					CT_RABoss_Announce(format(CT_RABOSS_MRGROBBULUS_AFFLICTED, playername), CT_RABoss_Mods["Abomination wing: Grobbulus"]["announce"]);
					CT_RABoss_PlaySound(3);
				end
			end
		
			if ( CT_RA_Level >= 1 and CT_RABoss_Mods["Abomination wing: Grobbulus"]["announce"] ) then
				local i,iconid;
				for i = 8, 1, -1 do
					if CT_RABoss_Mods["Abomination wing: Grobbulus"]["icons"][i] == false then
						iconid = i;
						break;
					end
				end

				local i;
				for i = 1, GetNumRaidMembers() do
					if ( UnitName("raid"..i) == playername and iconid ) then
						if ( not GetRaidTargetIndex("raid"..i) or ( not CT_RABoss_Mods["Abomination wing: Grobbulus"]["icons"][GetRaidTargetIndex("raid"..i)] == playername ) ) then
							SetRaidTargetIcon("raid"..i, iconid);
							CT_RABoss_Mods["Abomination wing: Grobbulus"]["icons"][iconid] = playername;
							CT_RABoss_Schedule("CT_RABoss_MRGrobbulus_EventHandler", 10, "removeicon"..playername);
							break;
						end
					end
				end
			end
		end


	elseif ( strsub( event, 1, 10 ) == "removeicon" ) then
		if ( CT_RA_Level >= 1 and CT_RABoss_Mods["Abomination wing: Grobbulus"]["announce"] ) then
			local playername = strsub( event, 11 );
			if ( playername ) then
				local i;
				for i = 1, GetNumRaidMembers() do
					if ( UnitName("raid"..i) == playername and GetRaidTargetIndex("raid"..i) ) then
						CT_RABoss_Mods["Abomination wing: Grobbulus"]["icons"][GetRaidTargetIndex("raid"..i)] = false;
						SetRaidTargetIcon("raid"..i, 0);
						break;
					end
				end
			end
		end
	end
end

-- Gluth - (22/08/2006) - Changed over to chat_msg_addon.
function CT_RABoss_MRGluth_OnLoad()
	CT_RABoss_AddMod("Abomination wing: Gluth", CT_RABOSS_MRGLUTH_INFO, 1, CT_RABOSS_LOCATIONS_MRNAXXRAMAS);
	CT_RABoss_AddEvent("Abomination wing: Gluth", "CHAT_MSG_MONSTER_EMOTE", CT_RABoss_MRGluth_EventHandler);
	CT_RABoss_AddEvent("Abomination wing: Gluth", "CHAT_MSG_SPELL_PERIODIC_PARTY_DAMAGE", CT_RABoss_MRGluth_EventHandler);
	CT_RABoss_AddEvent("Abomination wing: Gluth", "CHAT_MSG_SPELL_PERIODIC_FRIENDLYPLAYER_DAMAGE", CT_RABoss_MRGluth_EventHandler);
	CT_RABoss_AddEvent("Abomination wing: Gluth", "CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE", CT_RABoss_MRGluth_EventHandler);
	CT_RABoss_AddEvent("Abomination wing: Gluth", "CHAT_MSG_SPELL_PERIODIC_CREATURE_BUFFS", CT_RABoss_MRGluth_EventHandler);
	CT_RABoss_AddEvent("Abomination wing: Gluth", "CHAT_MSG_SPELL_CREATURE_VS_SELF_DAMAGE", CT_RABoss_MRGluth_EventHandler);
	CT_RABoss_AddEvent("Abomination wing: Gluth", "CHAT_MSG_SPELL_CREATURE_VS_PARTY_DAMAGE", CT_RABoss_MRGluth_EventHandler);
	CT_RABoss_AddEvent("Abomination wing: Gluth", "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE", CT_RABoss_MRGluth_EventHandler);
	CT_RABoss_AddEvent("Abomination wing: Gluth", "CHAT_MSG_ADDON", CT_RABoss_MRGluth_EventHandler);
	CT_RABoss_AddEvent("Abomination wing: Gluth", "PLAYER_REGEN_DISABLED", CT_RABoss_MRGluth_EventHandler);

	CT_RABoss_AddDropDownButton("Abomination wing: Gluth", { CT_RABOSS_ANNOUNCE, CT_RABOSS_ANNOUNCE_INFO .. CT_RABOSS_REQ_LEADER_OR_PROM }, "CT_RABoss_ModInfo", "announce", "CT_RABoss_SetInfo");
	CT_RABoss_AddDropDownButton("Abomination wing: Gluth", { CT_RABOSS_MRGLUTH_FRENZY_ALERT, CT_RABOSS_MRGLUTH_FRENZY_ALERT_INFO }, "CT_RABoss_ModInfo", "frenzyalert", "CT_RABoss_SetInfo");
	CT_RABoss_AddDropDownButton("Abomination wing: Gluth", { CT_RABOSS_MRGLUTH_FEAR_ALERT, CT_RABOSS_MRGLUTH_FEAR_ALERT_INFO }, "CT_RABoss_ModInfo", "fearalert", "CT_RABoss_SetInfo");

	CT_RABoss_SetVar("Abomination wing: Gluth", "frenzyalert", 1);
	CT_RABoss_SetVar("Abomination wing: Gluth", "fearalert", 1);
end

function CT_RABoss_MRGluth_Start()
	CT_RABoss_Announce(CT_RABOSS_MRGLUTH_ENGAGED, CT_RABoss_Mods["Abomination wing: Gluth"]["announce"]);
	CT_RABoss_PlaySound(3);
	CT_RABoss_Schedule("CT_RABoss_MRGluth_EventHandler", 100, "decimatewarn");
	CT_RABoss_Mods["Abomination wing: Gluth"]["lastaction"] = time();
	CT_RABoss_Mods["Abomination wing: Gluth"]["engaged"] = true;

	if ( CT_RA_Level >= 1 and CT_RABoss_Mods["Abomination wing: Gluth"]["announce"] ) then
		CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "1", "20", CT_RABOSS_MRGLUTH_DECIMATESTRING, "105", "255*0*0"));
	end
end

function CT_RABoss_MRGluth_EventHandler(event)
	if ( not CT_RABoss_Mods["Abomination wing: Gluth"] or not CT_RABoss_Mods["Abomination wing: Gluth"]["status"] or not CT_RABoss_Mods["Abomination wing: Gluth"].enabled ) then
		return;
	end

	if ( CT_RABoss_Mods["Abomination wing: Gluth"]["engaged"] and ( not CT_RABoss_Mods["Abomination wing: Gluth"]["lastaction"] or ( time() - CT_RABoss_Mods["Abomination wing: Gluth"]["lastaction"] ) > 60 ) ) then
		CT_RABoss_Mods["Abomination wing: Gluth"]["engaged"] = false;
	end

	if ( event == "CHAT_MSG_MONSTER_EMOTE" and arg2 == CT_RABOSS_MRGLUTH_BOSSNAME ) then
		if ( arg1 == CT_RABOSS_MRGLUTH_FRENZYSTRING and CT_RABoss_Mods["Abomination wing: Gluth"]["frenzyalert"] ) then
			CT_RABoss_Announce(CT_RABOSS_MRGLUTH_FRENZYWARNING, CT_RABoss_Mods["Abomination wing: Gluth"]["announce"]);
			CT_RABoss_PlaySound(2);
			CT_RABoss_Mods["Abomination wing: Gluth"]["lastaction"] = time();
		end

	elseif ( event == "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE" or event == "CHAT_MSG_SPELL_CREATURE_VS_PARTY_DAMAGE" or event == "CHAT_MSG_SPELL_CREATURE_VS_SELF_DAMAGE" ) then
		if ( string.find(arg1, CT_RABOSS_MRGLUTH_DECIMATESTRING) and not CT_RABoss_Mods["Abomination wing: Gluth"]["decimated"] ) then
			CT_RABoss_Mods["Abomination wing: Gluth"]["decimated"] = true;
			CT_RABoss_Announce(CT_RABOSS_MRGLUTH_DECIMATEWARNING, CT_RABoss_Mods["Abomination wing: Gluth"]["announce"]);
			CT_RABoss_PlaySound(2);
			CT_RABoss_Schedule("CT_RABoss_MRGluth_EventHandler", 105, "decimatewarn");
			CT_RABoss_Schedule("CT_RABoss_MRGluth_EventHandler", 5, "undecimate");
			CT_RABoss_Mods["Abomination wing: Gluth"]["lastaction"] = time();

			if ( CT_RA_Level >= 1 and CT_RABoss_Mods["Abomination wing: Gluth"]["announce"] ) then
				CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "1", "20", CT_RABOSS_MRGLUTH_DECIMATESTRING, "110", "255*0*0"));
			end
		end

	elseif ( event == "CHAT_MSG_SPELL_PERIODIC_PARTY_DAMAGE" or event == "CHAT_MSG_SPELL_PERIODIC_FRIENDLYPLAYER_DAMAGE" or event == "CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE" ) then
		if ( string.find(arg1, CT_RABOSS_MRGLUTH_FEARSTRING) and CT_RABoss_Mods["Abomination wing: Gluth"]["fearalert"] and not CT_RABoss_Mods["Abomination wing: Gluth"]["feartrip"] ) then
			CT_RABoss_Mods["Abomination wing: Gluth"]["feartrip"] = true;
			CT_RABoss_Announce(CT_RABOSS_MRGLUTH_FEARWARNING, CT_RABoss_Mods["Abomination wing: Gluth"]["announce"]);
			CT_RABoss_PlaySound(2);
			CT_RABoss_Schedule("CT_RABoss_MRGluth_EventHandler", 15, "prefear");
			CT_RABoss_Mods["Abomination wing: Gluth"]["lastaction"] = time();

			if ( CT_RA_Level >= 1 and CT_RABoss_Mods["Abomination wing: Gluth"]["announce"] ) then
				CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "2", "20", CT_RABOSS_MRGLUTH_FEAR, "20", "0*0*255"));
			end
		end

	elseif ( event == "PLAYER_REGEN_DISABLED" and not CT_RABoss_Mods["Abomination wing: Gluth"]["engaged"] ) then
		if ( not CT_RABoss_Mods["Abomination wing: Gluth"]["engaged"] ) then
			CT_RABoss_Schedule("CT_RABoss_MRGluth_EventHandler", 5, "engagecheck");
		end

	elseif ( event == "CHAT_MSG_ADDON" and arg1 == "CTRA" ) then
		if ( arg2 == "GLUTHENGSYNC" and not CT_RABoss_Mods["Abomination wing: Gluth"]["engaged"] ) then
			CT_RABoss_MRGluth_Start();
		end

	elseif ( event == "engagecheck" and not CT_RABoss_Mods["Abomination wing: Gluth"]["engaged"] ) then
		if ( UnitName("target") == CT_RABOSS_MRGLUTH_BOSSNAME and UnitAffectingCombat("target") ) then
			CT_RABoss_MRGluth_Start();
			CT_RA_SendMessage("GLUTHENGSYNC");

		elseif ( UnitName("playertarget") == CT_RABOSS_MRGLUTH_BOSSNAME and UnitAffectingCombat("playertarget") ) then
			CT_RABoss_MRGluth_Start();
			CT_RA_SendMessage("GLUTHENGSYNC");
		else
			local i
			for i = 1, GetNumRaidMembers(), 1 do
				if ( UnitName("raid"..i.."target") == CT_RABOSS_MRGLUTH_BOSSNAME and UnitAffectingCombat("raid"..i.."target")) then
					CT_RABoss_MRGluth_Start();
					CT_RA_SendMessage("GLUTHENGSYNC");
					break;
				end
			end
		end

	elseif ( event == "undecimate" ) then
		CT_RABoss_Mods["Abomination wing: Gluth"]["decimated"] = false;

	elseif ( event == "decimatewarn" ) then
		CT_RABoss_Announce(CT_RABOSS_MRGLUTH_DECIMATESOON, CT_RABoss_Mods["Abomination wing: Gluth"]["announce"]);
		CT_RABoss_PlaySound(2);

	elseif ( event == "prefear" ) then
		CT_RABoss_Mods["Abomination wing: Gluth"]["feartrip"] = false;
		CT_RABoss_Announce(CT_RABOSS_MRGLUTH_FEAR5SEC, CT_RABoss_Mods["Abomination wing: Gluth"]["announce"]);
		CT_RABoss_PlaySound(3);
	end
end


-- Thaddius - (23/08/2006) - Updated charge checking script.
function CT_RABoss_MRThaddius_OnLoad()
	CT_RABoss_AddMod("Abomination wing: Thaddius", CT_RABOSS_MRTHADDIUS_INFO, 1, CT_RABOSS_LOCATIONS_MRNAXXRAMAS);
	CT_RABoss_AddEvent("Abomination wing: Thaddius", "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE", CT_RABoss_MRThaddius_EventHandler);
	CT_RABoss_AddEvent("Abomination wing: Thaddius", "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_BUFF", CT_RABoss_MRThaddius_EventHandler);
	CT_RABoss_AddEvent("Abomination wing: Thaddius", "CHAT_MSG_SPELL_PERIODIC_CREATURE_BUFFS", CT_RABoss_MRThaddius_EventHandler);
	CT_RABoss_AddEvent("Abomination wing: Thaddius", "CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE", CT_RABoss_MRThaddius_EventHandler);
	CT_RABoss_AddEvent("Abomination wing: Thaddius", "CHAT_MSG_MONSTER_YELL", CT_RABoss_MRThaddius_EventHandler);
	CT_RABoss_AddEvent("Abomination wing: Thaddius", "PLAYER_AURAS_CHANGED", CT_RABoss_MRThaddius_EventHandler);

	CT_RABoss_AddDropDownButton("Abomination wing: Thaddius", { CT_RABOSS_ANNOUNCE, CT_RABOSS_ANNOUNCE_INFO .. CT_RABOSS_REQ_LEADER_OR_PROM }, "CT_RABoss_ModInfo", "announce", "CT_RABoss_SetInfo");
	CT_RABoss_AddDropDownButton("Abomination wing: Thaddius", { CT_RABOSS_MRTHADDIUS_SURGE_ALERT, CT_RABOSS_MRTHADDIUS_SURGE_ALERT_INFO }, "CT_RABoss_ModInfo", "surgealert", "CT_RABoss_SetInfo");

	CT_RABoss_SetVar("Abomination wing: Thaddius", "surgealert", 1);
end

function CT_RABoss_MRThaddius_EventHandler(event)
	if ( not CT_RABoss_Mods["Abomination wing: Thaddius"] or not CT_RABoss_Mods["Abomination wing: Thaddius"]["status"] or not CT_RABoss_Mods["Abomination wing: Thaddius"].enabled ) then
		return;
	end

	if ( event == "CHAT_MSG_MONSTER_YELL" ) then
		if ( arg1 == CT_RABOSS_MRTHADDIUS_PHASE1_YELL1 or arg1 == CT_RABOSS_MRTHADDIUS_PHASE1_YELL2 ) then
			if ( not CT_RABoss_Mods["Abomination wing: Thaddius"]["firstyell"] ) then
				CT_RABoss_Announce(CT_RABOSS_MRTHADDIUS_PHASE1, CT_RABoss_Mods["Abomination wing: Thaddius"]["announce"]);
				CT_RABoss_PlaySound(3);
				CT_RABoss_Schedule("CT_RABoss_MRThaddius_EventHandler", 15, "throw5");
				CT_RABoss_Schedule("CT_RABoss_MRThaddius_EventHandler", 20, "throw");
				CT_RABoss_Schedule("CT_RABoss_MRThaddius_EventHandler", 5, "yellreset");
				CT_RABoss_Mods["Abomination wing: Thaddius"]["firstyell"] = true;
				CT_RABoss_Mods["Abomination wing: Thaddius"]["lastaction"] = time();
			end

		elseif ( arg1 == CT_RABOSS_MRTHADDIUS_PHASE2_YELL1 or arg1 == CT_RABOSS_MRTHADDIUS_PHASE2_YELL2 or arg1 == CT_RABOSS_MRTHADDIUS_PHASE2_YELL3 ) then
			CT_RABoss_Announce(CT_RABOSS_MRTHADDIUS_PHASE2, CT_RABoss_Mods["Abomination wing: Thaddius"]["announce"]);
			CT_RABoss_PlaySound(3);
			CT_RABoss_UnSchedule("CT_RABoss_MRThaddius_EventHandler", "throw5");
			CT_RABoss_UnSchedule("CT_RABoss_MRThaddius_EventHandler", "throw");
			CT_RABoss_Schedule("CT_RABoss_MRThaddius_EventHandler", 30, "enragetimer");
			CT_RABoss_Mods["Abomination wing: Thaddius"]["enrageleft"] = 4.5;
			CT_RABoss_Mods["Abomination wing: Thaddius"]["lastaction"] = time();

		elseif ( arg1 == CT_RABOSS_MRTHADDIUS_DEAD ) then
			CT_RABoss_UnSchedule("CT_RABoss_MRThaddius_EventHandler");
		end

	elseif ( event == "CHAT_MSG_SPELL_PERIODIC_CREATURE_BUFFS" ) then
		if ( arg1 == CT_RABOSS_MRTHADDIUS_SURGESTRING and CT_RABoss_Mods["Abomination wing: Thaddius"]["surgealert"] ) then
			CT_RABoss_Announce(CT_RABOSS_MRTHADDIUS_SURGE, CT_RABoss_Mods["Abomination wing: Thaddius"]["announce"]);
			CT_RABoss_PlaySound(2);
			CT_RABoss_Mods["Abomination wing: Thaddius"]["lastaction"] = time();
		end

	elseif ( event == "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE" or event == "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_BUFF" ) then
		if ( arg1 == CT_RABOSS_MRTHADDIUS_POLARITYSTRING ) then
			CT_RABoss_Announce(CT_RABOSS_MRTHADDIUS_POLARITYWARN, CT_RABoss_Mods["Abomination wing: Thaddius"]["announce"]);
			CT_RABoss_PlaySound(3);
			CT_RABoss_Mods["Abomination wing: Thaddius"]["lastaction"] = time();

		elseif ( arg1 == CT_RABOSS_MRTHADDIUS_SHIFTSTRING ) then
			CT_RABoss_Announce(CT_RABOSS_MRTHADDIUS_SHIFTWARN, CT_RABoss_Mods["Abomination wing: Thaddius"]["announce"]);
			CT_RABoss_PlaySound(1);
			CT_RABoss_Mods["Abomination wing: Thaddius"]["lastaction"] = time();
			CT_RABoss_Mods["Abomination wing: Thaddius"]["debuffcheck"] = true;

			if ( CT_RA_Level >= 1 and CT_RABoss_Mods["Abomination wing: Thaddius"]["announce"] ) then
				CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "1", "20", CT_RABOSS_MRTHADDIUS_POLARITY, "30", "255*0*0"));
			end
		end

	elseif ( event == "CHAT_MSG_MONSTER_EMOTE" and arg2 == CT_RABOSS_MRTHADDIUS_BOSSNAME ) then
		if ( arg1 == CT_RABOSS_MRTHADDIUS_BERSERKSTRING ) then
			CT_RABoss_Announce(CT_RABOSS_MRTHADDIUS_BERSERKWARNING, CT_RABoss_Mods["Abomination wing: Thaddius"]["announce"]);
			CT_RABoss_PlaySound(1);
			CT_RABoss_UnSchedule("CT_RABoss_MRThaddius_EventHandler", "enragetimer");
			CT_RABoss_UnSchedule("CT_RABoss_MRThaddius_EventHandler", "enrage15");
			CT_RABoss_UnSchedule("CT_RABoss_MRThaddius_EventHandler", "enrage5");
			CT_RABoss_Mods["Abomination wing: Thaddius"]["lastaction"] = time();
		end

	elseif ( event == "PLAYER_AURAS_CHANGED" and CT_RABoss_Mods["Abomination wing: Thaddius"]["debuffcheck"] ) then
		local i = 1;
		local charge = nil;
		while UnitDebuff("player", i) do
			local t,a = UnitDebuff("player", i);
			if ( t == CT_RABOSS_MRTHADDIUS_POSITIVE or t == CT_RABOSS_MRTHADDIUS_NEGATIVE ) then
				if ( a > 1 ) then
					return;
				end

				charge = t;
			end
			i = i + 1;
		end
	
		if ( charge == nil ) then
			return;
		elseif ( charge ) then
			CT_RABoss_Mods["Abomination wing: Thaddius"]["debuffcheck"] = false;
			if ( charge == CT_RABoss_Mods["Abomination wing: Thaddius"]["oldcharge"] ) then
				CT_RABoss_Announce(CT_RABOSS_MRTHADDIUS_NOCHANGEWARN);
			elseif ( charge == CT_RABOSS_MRTHADDIUS_POSITIVE ) then
				CT_RABoss_Announce(CT_RABOSS_MRTHADDIUS_POSITIVEWARN);
			elseif ( charge == CT_RABOSS_MRTHADDIUS_NEGATIVE ) then
				CT_RABoss_Announce(CT_RABOSS_MRTHADDIUS_NEGATIVEWARN);
			end
		end
		CT_RABoss_Mods["Abomination wing: Thaddius"]["oldcharge"] = charge;

	elseif ( event == "enragetimer") then
		if ( not CT_RABoss_Mods["Abomination wing: Thaddius"]["lastaction"] or ( time() - CT_RABoss_Mods["Abomination wing: Thaddius"]["lastaction"] ) > 60 ) then
			return;

		elseif ( CT_RABoss_Mods["Abomination wing: Thaddius"]["enrageleft"] == 0.5 ) then
			CT_RABoss_Schedule("CT_RABoss_MRThaddius_EventHandler", 15, "enrage15");
			CT_RABoss_Schedule("CT_RABoss_MRThaddius_EventHandler", 25, "enrage5");
			CT_RABoss_Announce(format(CT_RABOSS_MRTHADDIUS_SECWARN, "30"), CT_RABoss_Mods["Abomination wing: Thaddius"]["announce"]);
			CT_RABoss_PlaySound(3);
		else
			if ( CT_RABoss_Mods["Abomination wing: Thaddius"]["enrageleft"] == 1 ) then
				CT_RABoss_Announce(CT_RABOSS_MRTHADDIUS_1MINWARN, CT_RABoss_Mods["Abomination wing: Thaddius"]["announce"]);
			else
				CT_RABoss_Announce(format(CT_RABOSS_MRTHADDIUS_WARN, CT_RABoss_Mods["Abomination wing: Thaddius"]["enrageleft"]), CT_RABoss_Mods["Abomination wing: Thaddius"]["announce"]);
			end

			CT_RABoss_Mods["Abomination wing: Thaddius"]["enrageleft"] = CT_RABoss_Mods["Abomination wing: Thaddius"]["enrageleft"]-0.5;
			CT_RABoss_Schedule("CT_RABoss_MRThaddius_EventHandler", 30, "enragetimer");
			CT_RABoss_PlaySound(3);
		end
	
	elseif ( event == "throw5" ) then
		CT_RABoss_Announce(CT_RABOSS_MRTHADDIUS_THROWMSG5, CT_RABoss_Mods["Abomination wing: Thaddius"]["announce"]);

	elseif ( event == "throw" ) then
		if ( not CT_RABoss_Mods["Abomination wing: Thaddius"]["lastaction"] or ( time() - CT_RABoss_Mods["Abomination wing: Thaddius"]["lastaction"] ) > 60 ) then
			return;
		else
			CT_RABoss_Announce(CT_RABOSS_MRTHADDIUS_THROWMSG, CT_RABoss_Mods["Abomination wing: Thaddius"]["announce"]);
			CT_RABoss_Schedule("CT_RABoss_MRThaddius_EventHandler", 16, "throw5");
			CT_RABoss_Schedule("CT_RABoss_MRThaddius_EventHandler", 21, "throw");
		end

	elseif ( event == "yellreset" ) then
		CT_RABoss_Mods["Abomination wing: Thaddius"]["firstyell"] = false;

	elseif ( event == "enrage15" ) then
		CT_RABoss_Announce(format(CT_RABOSS_MRTHADDIUS_SECWARN, "15"), CT_RABoss_Mods["Abomination wing: Thaddius"]["announce"]);
		CT_RABoss_PlaySound(3);

	elseif ( event == "enrage5" ) then
		CT_RABoss_Announce(format(CT_RABOSS_MRTHADDIUS_SECWARN, "5"), CT_RABoss_Mods["Abomination wing: Thaddius"]["announce"]);
		CT_RABoss_PlaySound(3);
	end
end