-- Midnight Reveries Naxxramas Boss Mods v7.23 - 21/09/2006
-- Updated Four Horsemen code.

-- Loading Modules
tinsert(CT_RABoss_ModsToLoad, "CT_RABoss_MRRazuvious_OnLoad");
tinsert(CT_RABoss_ModsToLoad, "CT_RABoss_MRGothik_OnLoad");
tinsert(CT_RABoss_ModsToLoad, "CT_RABoss_MRHorsemen_OnLoad");


-- Instructor Razuvious (01/09/2006) - Added shieldwall anouncements.
function CT_RABoss_MRRazuvious_OnLoad()
	CT_RABoss_AddMod("Deathknight wing: Instructor Razuvious", CT_RABOSS_MRRAZUVIOUS_INFO, 1, CT_RABOSS_LOCATIONS_MRNAXXRAMAS);
	CT_RABoss_AddEvent("Deathknight wing: Instructor Razuvious", "CHAT_MSG_MONSTER_YELL", CT_RABoss_MRRazuvious_EventHandler);
	CT_RABoss_AddEvent("Deathknight wing: Instructor Razuvious", "CHAT_MSG_SPELL_CREATURE_VS_SELF_DAMAGE", CT_RABoss_MRRazuvious_EventHandler);
	CT_RABoss_AddEvent("Deathknight wing: Instructor Razuvious", "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE", CT_RABoss_MRRazuvious_EventHandler);
	CT_RABoss_AddEvent("Deathknight wing: Instructor Razuvious", "CHAT_MSG_SPELL_CREATURE_VS_PARTY_DAMAGE", CT_RABoss_MRRazuvious_EventHandler);
	CT_RABoss_AddEvent("Deathknight wing: Instructor Razuvious", "CHAT_MSG_COMBAT_CREATURE_VS_CREATURE_HITS", CT_RABoss_MRRazuvious_EventHandler);
	CT_RABoss_AddEvent("Deathknight wing: Instructor Razuvious", "CHAT_MSG_COMBAT_CREATURE_VS_PARTY_HITS", CT_RABoss_MRRazuvious_EventHandler);
	CT_RABoss_AddEvent("Deathknight wing: Instructor Razuvious", "CHAT_MSG_COMBAT_CREATURE_VS_SELF_HITS", CT_RABoss_MRRazuvious_EventHandler);
	CT_RABoss_AddEvent("Deathknight wing: Instructor Razuvious", "CHAT_MSG_SPELL_PERIODIC_FRIENDLYPLAYER_BUFFS", CT_RABoss_MRRazuvious_EventHandler);
	CT_RABoss_AddEvent("Deathknight wing: Instructor Razuvious", "CHAT_MSG_SPELL_PERIODIC_PARTY_BUFFS", CT_RABoss_MRRazuvious_EventHandler);
	CT_RABoss_AddEvent("Deathknight wing: Instructor Razuvious", "CHAT_MSG_SPELL_PERIODIC_CREATURE_BUFFS", CT_RABoss_MRRazuvious_EventHandler);
	CT_RABoss_AddEvent("Deathknight wing: Instructor Razuvious", "CHAT_MSG_SPELL_PERIODIC_SELF_BUFFS", CT_RABoss_MRRazuvious_EventHandler);

	CT_RABoss_AddDropDownButton("Deathknight wing: Instructor Razuvious", { CT_RABOSS_ANNOUNCE, CT_RABOSS_ANNOUNCE_INFO .. CT_RABOSS_REQ_LEADER_OR_PROM }, "CT_RABoss_ModInfo", "announce", "CT_RABoss_SetInfo");
end

function CT_RABoss_MRRazuvious_EventHandler(event)
	if ( not CT_RABoss_Mods["Deathknight wing: Instructor Razuvious"] or not CT_RABoss_Mods["Deathknight wing: Instructor Razuvious"]["status"] or not CT_RABoss_Mods["Deathknight wing: Instructor Razuvious"].enabled ) then
		return;
	end

	if ( event == "CHAT_MSG_MONSTER_YELL" ) then
		if ( arg1 == CT_RABOSS_MRRAZUVIOUS_YELL1 or arg1 == CT_RABOSS_MRRAZUVIOUS_YELL2 or arg1 == CT_RABOSS_MRRAZUVIOUS_YELL3 or arg1 == CT_RABOSS_MRRAZUVIOUS_YELL4 ) then
			CT_RABoss_Announce(CT_RABOSS_MRRAZUVIOUS_ENGAGED, CT_RABoss_Mods["Deathknight wing: Instructor Razuvious"]["announce"]);
			CT_RABoss_PlaySound(3);
			CT_RABoss_UnSchedule("CT_RABoss_MRRazuvious_EventHandler");
			CT_RABoss_Schedule("CT_RABoss_MRRazuvious_EventHandler", 15.5, "warn10");
			CT_RABoss_Mods["Deathknight wing: Instructor Razuvious"]["lastaction"] = time();

			if ( CT_RA_Level >= 1 and CT_RABoss_Mods["Deathknight wing: Instructor Razuvious"]["announce"] ) then
				CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "1", "25.5", CT_RABOSS_MRRAZUVIOUS_SHOUT, "25.5", "255*0*0"));
			end

		elseif ( arg1 == CT_RABOSS_MRRAZUVIOUS_DEAD_YELL1 ) then
			CT_RABoss_UnSchedule("CT_RABoss_MRRazuvious_EventHandler");
		end

	elseif ( event == "CHAT_MSG_SPELL_CREATURE_VS_SELF_DAMAGE" or event == "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE" or event == "CHAT_MSG_SPELL_CREATURE_VS_PARTY_DAMAGE" ) then
		if ( string.find(arg1, CT_RABOSS_MRRAZUVIOUS_SHOUT) and not CT_RABoss_Mods["Deathknight wing: Instructor Razuvious"]["shouttrip"] ) then
			CT_RABoss_UnSchedule("CT_RABoss_MRRazuvious_EventHandler");
			CT_RABoss_Schedule("CT_RABoss_MRRazuvious_EventHandler", 15.5, "warn10");
			CT_RABoss_Schedule("CT_RABoss_MRRazuvious_EventHandler", 5, "preshout");
			CT_RABoss_Mods["Deathknight wing: Instructor Razuvious"]["shouttrip"] = true;
			CT_RABoss_Mods["Deathknight wing: Instructor Razuvious"]["lastaction"] = time();

			if ( not CT_RABoss_Mods["Deathknight wing: Instructor Razuvious"]["shoutwarn"] ) then
				CT_RABoss_Announce(CT_RABOSS_MRRAZUVIOUS_SHOUTNEXT, CT_RABoss_Mods["Deathknight wing: Instructor Razuvious"]["announce"]);
				CT_RABoss_PlaySound(2);
			end

			if ( CT_RA_Level >= 1 and CT_RABoss_Mods["Deathknight wing: Instructor Razuvious"]["announce"] ) then
				CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "1", "25.5", CT_RABOSS_MRRAZUVIOUS_SHOUT, "25.5", "255*0*0"));
			end
		end

	elseif ( event == "CHAT_MSG_SPELL_PERIODIC_SELF_BUFFS" or event == "CHAT_MSG_SPELL_PERIODIC_FRIENDLYPLAYER_BUFFS" or event == "CHAT_MSG_SPELL_PERIODIC_PARTY_BUFFS" or event == "CHAT_MSG_SPELL_PERIODIC_CREATURE_BUFFS" ) then
		if ( arg1 == CT_RABOSS_MRRAZUVIOUS_SHIELDSTRING ) then
			if ( CT_RA_Level >= 1 and CT_RABoss_Mods["Deathknight wing: Instructor Razuvious"]["announce"] ) then
				CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "2", "20", CT_RABOSS_MRRAZUVIOUS_SHIELDWALL, "20", "0*0*255"));
			end
		end
			
	elseif ( event == "CHAT_MSG_COMBAT_CREATURE_VS_CREATURE_HITS" or event == "CHAT_MSG_COMBAT_CREATURE_VS_PARTY_HITS" or event == "CHAT_MSG_COMBAT_CREATURE_VS_SELF_HITS" ) then
		if ( string.find(arg1, CT_RABOSS_MRRAZUVIOUS_BOSSNAME) or string.find(arg1, CT_RABOSS_MRRAZUVIOUS_STUDENT) ) then
			CT_RABoss_Mods["Deathknight wing: Instructor Razuvious"]["lastaction"] = time();
		end	

	elseif ( event == "preshout" ) then
		CT_RABoss_Mods["Deathknight wing: Instructor Razuvious"]["shouttrip"] = false;

	elseif ( event == "warn10" ) then
		CT_RABoss_Announce(format(CT_RABOSS_MRRAZUVIOUS_SHOUTWARN, "10"), CT_RABoss_Mods["Deathknight wing: Instructor Razuvious"]["announce"]);
		CT_RABoss_PlaySound(3);
		CT_RABoss_Schedule("CT_RABoss_MRRazuvious_EventHandler", 5, "warn5");
		CT_RABoss_Mods["Deathknight wing: Instructor Razuvious"]["shoutwarn"] = false;

	elseif ( event == "warn5" ) then
		CT_RABoss_Announce(format(CT_RABOSS_MRRAZUVIOUS_SHOUTWARN, "5"), CT_RABoss_Mods["Deathknight wing: Instructor Razuvious"]["announce"]);
		CT_RABoss_PlaySound(3);
		CT_RABoss_Schedule("CT_RABoss_MRRazuvious_EventHandler", 2, "warn3");

	elseif ( event == "warn3" ) then
		CT_RABoss_Announce(format(CT_RABOSS_MRRAZUVIOUS_SHOUTWARN, "3"), CT_RABoss_Mods["Deathknight wing: Instructor Razuvious"]["announce"]);
		CT_RABoss_PlaySound(3);
		CT_RABoss_Schedule("CT_RABoss_MRRazuvious_EventHandler", 3, "shoutcast");

	elseif ( event == "shoutcast" ) then
		if ( not CT_RABoss_Mods["Deathknight wing: Instructor Razuvious"]["lastaction"] or ( time() - CT_RABoss_Mods["Deathknight wing: Instructor Razuvious"]["lastaction"] ) > 30 ) then
			return;
		else
			CT_RABoss_Mods["Deathknight wing: Instructor Razuvious"]["shoutwarn"] = true;
			CT_RABoss_Announce(CT_RABOSS_MRRAZUVIOUS_SHOUTNEXT, CT_RABoss_Mods["Deathknight wing: Instructor Razuvious"]["announce"]);
			CT_RABoss_PlaySound(2);
			CT_RABoss_Schedule("CT_RABoss_MRRazuvious_EventHandler", 15, "warn10");

			if ( CT_RA_Level >= 1 and CT_RABoss_Mods["Deathknight wing: Instructor Razuvious"]["announce"] ) then
				CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "1", "25", CT_RABOSS_MRRAZUVIOUS_SHOUT, "25", "255*0*0"));
			end
		end
	end
end


-- Gothik the Harvester (19/08/2006) - Changed naming.
function CT_RABoss_MRGothik_OnLoad()
	CT_RABoss_AddMod("Deathknight wing: Gothik the Harvester", CT_RABOSS_MRGOTHIK_INFO, 1, CT_RABOSS_LOCATIONS_MRNAXXRAMAS);
	CT_RABoss_AddEvent("Deathknight wing: Gothik the Harvester", "CHAT_MSG_MONSTER_YELL", CT_RABoss_MRGothik_EventHandler);
	CT_RABoss_AddEvent("Deathknight wing: Gothik the Harvester", "CHAT_MSG_COMBAT_HOSTILE_DEATH", CT_RABoss_MRGothik_EventHandler);

	CT_RABoss_AddDropDownButton("Deathknight wing: Gothik the Harvester", { CT_RABOSS_ANNOUNCE, CT_RABOSS_ANNOUNCE_INFO .. CT_RABOSS_REQ_LEADER_OR_PROM }, "CT_RABoss_ModInfo", "announce", "CT_RABoss_SetInfo");
end

function CT_RABoss_MRGothik_EventHandler(event)
	if ( not CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"] or not CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["status"] or not CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"].enabled ) then
		return;
	end

	if ( event == "CHAT_MSG_MONSTER_YELL" ) then
		if ( string.find(arg1, CT_RABOSS_MRGOTHIK_PHASE1_YELL1) ) then
			CT_RABoss_Announce(CT_RABOSS_MRGOTHIK_ENGAGED, CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["announce"]);
			CT_RABoss_PlaySound(3);
			CT_RABoss_Schedule("CT_RABoss_MRGothik_EventHandler", 34, "inctimer");
			CT_RABoss_Schedule("CT_RABoss_MRGothik_EventHandler", 24, "inctrainee");
			CT_RABoss_Schedule("CT_RABoss_MRGothik_EventHandler", 74, "incknight");
			CT_RABoss_Schedule("CT_RABoss_MRGothik_EventHandler", 134, "incrider");
			CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["timeleft"] = 4;
			CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["stoptimer"] = false;
			CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["lastaction"] = time();

			if ( CT_RA_Level >= 1 and CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["announce"] ) then
				CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "1", "20", CT_RABOSS_MRGOTHIK_TRAINEES, "20", "0*255*0"));
				CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "2", "20", CT_RABOSS_MRGOTHIK_KNIGHTS, "70", "0*0*255"));
				CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "3", "20", CT_RABOSS_MRGOTHIK_RIDERS, "130", "255*0*0"));
			end

		elseif ( arg1 == CT_RABOSS_MRGOTHIK_PHASE2_YELL1 ) then
			CT_RABoss_Announce(CT_RABOSS_MRGOTHIK_INC, CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["announce"]);
			CT_RABoss_PlaySound(2);
			CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["stoptimer"] = true;
		end
	
	elseif ( event == "CHAT_MSG_COMBAT_HOSTILE_DEATH" ) then
		if ( string.find(arg1, CT_RABOSS_MRGOTHIK_TRAINEE) ) then
			CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["lastaction"] = time();

		elseif ( string.find(arg1, CT_RABOSS_MRGOTHIK_KNIGHT) ) then
			CT_RABoss_Announce(CT_RABOSS_MRGOTHIK_KNIGHT_DEAD, CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["announce"]);
			CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["lastaction"] = time();

		elseif ( string.find(arg1, CT_RABOSS_MRGOTHIK_RIDER) ) then
			CT_RABoss_Announce(CT_RABOSS_MRGOTHIK_RIDER_DEAD, CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["announce"]);
			CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["lastaction"] = time();
		end

	elseif ( event == "inctimer") then
		if ( not CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["lastaction"] or ( time() - CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["lastaction"] ) > 45 ) then
			CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["stoptimer"] = true;

		elseif ( CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["timeleft"] == 0.5 ) then
			CT_RABoss_Schedule("CT_RABoss_MRGothik_EventHandler", 20, "inc10");
			CT_RABoss_Announce(format(CT_RABOSS_MRGOTHIK_SECWARN, "30"), CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["announce"]);
			CT_RABoss_PlaySound(3);
		else
			if ( CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["timeleft"] == 1 ) then
				CT_RABoss_Announce(CT_RABOSS_MRGOTHIK_1MINWARN, CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["announce"]);
			else
				CT_RABoss_Announce(format(CT_RABOSS_MRGOTHIK_WARN, CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["timeleft"]), CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["announce"]);
			end

			CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["timeleft"] = CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["timeleft"]-0.5;
			CT_RABoss_Schedule("CT_RABoss_MRGothik_EventHandler", 30, "inctimer");
			CT_RABoss_PlaySound(3);
		end

	elseif ( event == "inctrainee" and not CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["stoptimer"] ) then
		CT_RABoss_Announce(format(CT_RABOSS_MRGOTHIK_ADD_INC, CT_RABOSS_MRGOTHIK_TRAINEES), CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["announce"]);
		CT_RABoss_PlaySound(3);
		CT_RABoss_Schedule("CT_RABoss_MRGothik_EventHandler", 20, "inctrainee");

		if ( CT_RA_Level >= 1 and CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["announce"] ) then
			CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "1", "20", CT_RABOSS_MRGOTHIK_TRAINEES, "20", "0*255*0"));
		end

	elseif ( event == "incknight" and not CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["stoptimer"] ) then
		CT_RABoss_Announce(format(CT_RABOSS_MRGOTHIK_ADD_INC, CT_RABOSS_MRGOTHIK_KNIGHTS), CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["announce"]);
		CT_RABoss_PlaySound(3);
		CT_RABoss_Schedule("CT_RABoss_MRGothik_EventHandler", 25, "incknight");

		if ( CT_RA_Level >= 1 and CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["announce"] ) then
			CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "2", "25", CT_RABOSS_MRGOTHIK_KNIGHTS, "25", "0*0*255"));
		end

	elseif ( event == "incrider" and not CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["stoptimer"] ) then
		CT_RABoss_Announce(format(CT_RABOSS_MRGOTHIK_ADD_INC, CT_RABOSS_MRGOTHIK_RIDERS), CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["announce"]);
		CT_RABoss_PlaySound(3);
		CT_RABoss_Schedule("CT_RABoss_MRGothik_EventHandler", 30, "incrider");

		if ( CT_RA_Level >= 1 and CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["announce"] ) then
			CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "3", "30", CT_RABOSS_MRGOTHIK_RIDERS, "30", "255*0*0"));
		end

	elseif ( event == "inc10" ) then
		CT_RABoss_Announce(format(CT_RABOSS_MRGOTHIK_SECWARN, "10"), CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["announce"]);
		CT_RABoss_PlaySound(3);

	end
end

-- The Four Horsemen (21/09/2006) - Updated code.
function CT_RABoss_MRHorsemen_OnLoad()
	CT_RABoss_AddMod("Deathknight wing: The Four Horsemen", CT_RABOSS_MRHORSEMEN_INFO, 1, CT_RABOSS_LOCATIONS_MRNAXXRAMAS);
	CT_RABoss_AddEvent("Deathknight wing: The Four Horsemen", "CHAT_MSG_SPELL_PERIODIC_CREATURE_BUFFS", CT_RABoss_MRHorsemen_EventHandler);
	CT_RABoss_AddEvent("Deathknight wing: The Four Horsemen", "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_BUFF", CT_RABoss_MRHorsemen_EventHandler);
	CT_RABoss_AddEvent("Deathknight wing: The Four Horsemen", "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE", CT_RABoss_MRHorsemen_EventHandler);
	CT_RABoss_AddEvent("Deathknight wing: The Four Horsemen", "CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE", CT_RABoss_MRHorsemen_EventHandler);
	CT_RABoss_AddEvent("Deathknight wing: The Four Horsemen", "CHAT_MSG_SPELL_PERIODIC_FRIENDLYPLAYER_DAMAGE", CT_RABoss_MRHorsemen_EventHandler);
	CT_RABoss_AddEvent("Deathknight wing: The Four Horsemen", "CHAT_MSG_SPELL_PERIODIC_PARTY_DAMAGE", CT_RABoss_MRHorsemen_EventHandler);

	CT_RABoss_AddDropDownButton("Deathknight wing: The Four Horsemen", { CT_RABOSS_ANNOUNCE, CT_RABOSS_ANNOUNCE_INFO .. CT_RABOSS_REQ_LEADER_OR_PROM }, "CT_RABoss_ModInfo", "announce", "CT_RABoss_SetInfo");
end

function CT_RABoss_MRHorsemen_Start()
	CT_RABoss_Announce(CT_RABOSS_MRHORSEMEN_ENGAGE, CT_RABoss_Mods["Deathknight wing: The Four Horsemen"]["announce"]);
	CT_RABoss_PlaySound(3);
	CT_RABoss_Mods["Deathknight wing: The Four Horsemen"]["engaged"] = true;
	CT_RABoss_Mods["Deathknight wing: The Four Horsemen"]["marks"] = 1;
	CT_RABoss_Mods["Deathknight wing: The Four Horsemen"]["lastaction"] = time();
	CT_RABoss_Schedule("CT_RABoss_MRHorsemen_EventHandler", 7, "mark5");

	if ( CT_RA_Level >= 1 and CT_RABoss_Mods["Deathknight wing: The Four Horsemen"]["announce"] ) then
		CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "1", "12", CT_RABOSS_MRHORSEMEN_MARK, "12", "255*0*0"));
	end
end

function CT_RABoss_MRHorsemen_EventHandler(event)

	if ( CT_RABoss_Mods["Deathknight wing: The Four Horsemen"] and ( not CT_RABoss_Mods["Deathknight wing: The Four Horsemen"]["lastaction"] or ( time() - CT_RABoss_Mods["Deathknight wing: The Four Horsemen"]["lastaction"] ) > 60 ) ) then
		CT_RABoss_Mods["Deathknight wing: The Four Horsemen"]["engaged"] = false;
	end

	if ( event == "CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE" or event == "CHAT_MSG_SPELL_PERIODIC_PARTY_DAMAGE" ) then
		if ( string.find(arg1, CT_RABOSS_MRHORSEMEN_MARKSTRING) ) then
			if ( not CT_RABoss_Mods["Deathknight wing: The Four Horsemen"]["engaged"] ) then
				CT_RABoss_Mods["Deathknight wing: The Four Horsemen"]["engaged"] = true;
				CT_RABoss_Mods["Deathknight wing: The Four Horsemen"]["marks"] = 1;
			end

			CT_RABoss_Announce(format(CT_RABOSS_MRHORSEMEN_MARKNOW, CT_RABoss_Mods["Deathknight wing: The Four Horsemen"]["marks"]), CT_RABoss_Mods["Deathknight wing: The Four Horsemen"]["announce"]);
			CT_RABoss_PlaySound(2);
			CT_RABoss_Schedule("CT_RABoss_MRHorsemen_EventHandler", 7, "mark5");
			CT_RABoss_Mods["Deathknight wing: The Four Horsemen"]["marks"] = CT_RABoss_Mods["Deathknight wing: The Four Horsemen"]["marks"] + 1;

			if ( CT_RA_Level >= 1 and CT_RABoss_Mods["Deathknight wing: The Four Horsemen"]["announce"] ) then
				CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "1", "12", CT_RABOSS_MRHORSEMEN_MARK, "12", "255*0*0"));
			end
		end

	elseif ( event == "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE" or event == "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_BUFF" ) then
		if ( string.find(arg1, CT_RABOSS_MRHORSEMEN_VOIDSTRING) ) then
			CT_RABoss_Announce(CT_RABOSS_MRHORSEMEN_VOIDWARN, CT_RABoss_Mods["Deathknight wing: The Four Horsemen"]["announce"]);
			CT_RABoss_PlaySound(3);
			CT_RABoss_Mods["Deathknight wing: The Four Horsemen"]["lastaction"] = time();

			if ( CT_RA_Level >= 1 and CT_RABoss_Mods["Deathknight wing: The Four Horsemen"]["announce"] ) then
				CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "2", "12", CT_RABOSS_MRHORSEMEN_VOID, "12", "255*0*0"));
			end

		elseif ( string.find(arg1, CT_RABOSS_MRHORSEMEN_METEORSTRING) and not CT_RABoss_Mods["Deathknight wing: The Four Horsemen"]["meteortrip"]) then
			CT_RABoss_Announce(CT_RABOSS_MRHORSEMEN_METEORWARN, CT_RABoss_Mods["Deathknight wing: The Four Horsemen"]["announce"]);
			CT_RABoss_PlaySound(3);
			CT_RABoss_Mods["Deathknight wing: The Four Horsemen"]["meteortrip"] = true;
			CT_RABoss_Schedule("CT_RABoss_MRHorsemen_EventHandler", 5, "unmeteor");
				CT_RABoss_Mods["Deathknight wing: The Four Horsemen"]["lastaction"] = time();

			if ( CT_RA_Level >= 1 and CT_RABoss_Mods["Deathknight wing: The Four Horsemen"]["announce"] ) then
				CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "3", "12", CT_RABOSS_MRHORSEMEN_METEOR, "12", "255*0*0"));
			end

		elseif ( string.find(arg1, CT_RABOSS_MRHORSEMEN_WRATHSTRING) and not CT_RABoss_Mods["Deathknight wing: The Four Horsemen"]["wrathtrip"] ) then
			CT_RABoss_Announce(CT_RABOSS_MRHORSEMEN_WRATHWARN, CT_RABoss_Mods["Deathknight wing: The Four Horsemen"]["announce"]);
			CT_RABoss_PlaySound(3);
			CT_RABoss_Mods["Deathknight wing: The Four Horsemen"]["wrathtrip"] = true;
			CT_RABoss_Schedule("CT_RABoss_MRHorsemen_EventHandler", 5, "unwrath");
			CT_RABoss_Mods["Deathknight wing: The Four Horsemen"]["lastaction"] = time();

			if ( CT_RA_Level >= 1 and CT_RABoss_Mods["Deathknight wing: The Four Horsemen"]["announce"] ) then
				CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "4", "12", CT_RABOSS_MRHORSEMEN_WRATH, "12", "255*0*0"));
			end
		end

	elseif ( event == "CHAT_MSG_SPELL_PERIODIC_CREATURE_BUFFS" ) then
		if ( string.find(arg1, CT_RABOSS_MRHORSEMEN_SHIELDSTRING) ) then
			if ( string.find(arg1, CT_RABOSS_MRHORSEMEN_THANE) ) then
				CT_RABoss_Announce(format(CT_RABOSS_MRHORSEMEN_SHIELDWARN, CT_RABOSS_MRHORSEMEN_THANE), CT_RABoss_Mods["Deathknight wing: The Four Horsemen"]["announce"]);
				CT_RABoss_PlaySound(2);
				CT_RABoss_Schedule("CT_RABoss_MRHorsemen_EventHandler", 20, "shieldover"..CT_RABOSS_MRHORSEMEN_THANE);
				CT_RABoss_Mods["Deathknight wing: The Four Horsemen"]["lastaction"] = time();

			elseif ( string.find(arg1, CT_RABOSS_MRHORSEMEN_MOGRAINE) ) then
				CT_RABoss_Announce(format(CT_RABOSS_MRHORSEMEN_SHIELDWARN, CT_RABOSS_MRHORSEMEN_MOGRANE), CT_RABoss_Mods["Deathknight wing: The Four Horsemen"]["announce"]);
				CT_RABoss_PlaySound(2);
				CT_RABoss_Schedule("CT_RABoss_MRHorsemen_EventHandler", 20, "shieldover"..CT_RABOSS_MRHORSEMEN_MOGRANE);	
				CT_RABoss_Mods["Deathknight wing: The Four Horsemen"]["lastaction"] = time();

			elseif ( string.find(arg1, CT_RABOSS_MRHORSEMEN_ZELIEK) ) then
				CT_RABoss_Announce(format(CT_RABOSS_MRHORSEMEN_SHIELDWARN, CT_RABOSS_MRHORSEMEN_ZELIEK), CT_RABoss_Mods["Deathknight wing: The Four Horsemen"]["announce"]);
				CT_RABoss_PlaySound(2);
				CT_RABoss_Schedule("CT_RABoss_MRHorsemen_EventHandler", 20, "shieldover"..CT_RABOSS_MRHORSEMEN_ZELIEK);
				CT_RABoss_Mods["Deathknight wing: The Four Horsemen"]["lastaction"] = time();

			elseif ( string.find(arg1, CT_RABOSS_MRHORSEMEN_BLAUMEUX) ) then
				CT_RABoss_Announce(format(CT_RABOSS_MRHORSEMEN_SHIELDWARN, CT_RABOSS_MRHORSEMEN_BLAUMEUX), CT_RABoss_Mods["Deathknight wing: The Four Horsemen"]["announce"]);
				CT_RABoss_PlaySound(2);
				CT_RABoss_Schedule("CT_RABoss_MRHorsemen_EventHandler", 20, "shieldover"..CT_RABOSS_MRHORSEMEN_BLAUMEUX);
				CT_RABoss_Mods["Deathknight wing: The Four Horsemen"]["lastaction"] = time();
			end
		end

	elseif ( strsub( event, 1, 10 ) == "shieldover" ) then
		local bossname = strsub( event, 11 );
		CT_RABoss_Announce(format(CT_RABOSS_MRHORSEMEN_SHIELDOVER, bossname), CT_RABoss_Mods["Deathknight wing: The Four Horsemen"]["announce"]);
		CT_RABoss_PlaySound(3);

	elseif ( event == "PLAYER_REGEN_DISABLED" and not CT_RABoss_Mods["Deathknight wing: The Four Horsemen"]["engaged"] ) then
		CT_RABoss_Schedule("CT_RABoss_MRHorsemen_EventHandler", 5, "engagecheck");	

	elseif ( event == "CHAT_MSG_ADDON" and arg1 == "CTRA" ) then
		if ( arg2 == "HORSEMENENGSYNC" and not CT_RABoss_Mods["Deathknight wing: The Four Horsemen"]["engaged"] ) then
			CT_RABoss_MRHorsemen_Start();
		end

	elseif ( event == "engagecheck" and not CT_RABoss_Mods["Deathknight wing: The Four Horsemen"]["engaged"] ) then
		if ( ( UnitName("target") == CT_RABOSS_MRHORSEMEN_THANE or UnitName("target") == CT_RABOSS_MRHORSEMEN_MOGRAINE or UnitName("target") == CT_RABOSS_MRHORSEMEN_ZELIEK or UnitName("target") == CT_RABOSS_MRHORSEMEN_BLAUMEUX ) and UnitAffectingCombat("target") ) then
			CT_RABoss_MRHorsemen_Start();
			CT_RA_SendMessage("HORSEMENENGSYNC");

		elseif ( ( UnitName("playertarget") == CT_RABOSS_MRHORSEMEN_THANE or UnitName("playertarget") == CT_RABOSS_MRHORSEMEN_MOGRAINE or UnitName("playertarget") == CT_RABOSS_MRHORSEMEN_ZELIEK or UnitName("playertarget") == CT_RABOSS_MRHORSEMEN_BLAUMEUX ) and UnitAffectingCombat("playertarget") ) then
			CT_RABoss_MRHorsemen_Start();
			CT_RA_SendMessage("HORSEMENENGSYNC");
		else
			local i
			for i = 1, GetNumRaidMembers(), 1 do
				if ( ( UnitName("raid"..i.."target") == CT_RABOSS_MRHORSEMEN_THANE or UnitName("raid"..i.."target") == CT_RABOSS_MRHORSEMEN_MOGRAINE or UnitName("raid"..i.."target") == CT_RABOSS_MRHORSEMEN_ZELIEK or UnitName("raid"..i.."target") == CT_RABOSS_MRHORSEMEN_BLAUMEUX ) and UnitAffectingCombat("raid"..i.."target") ) then
					CT_RABoss_MRMHorsemen_Start();
					CT_RA_SendMessage("HORSEMENENGSYNC");
					break;
				end
			end
		end

	elseif ( event == "mark5" ) then
		CT_RABoss_Announce(format(CT_RABOSS_MRHORSEMEN_MARKWARN, CT_RABoss_Mods["Deathknight wing: The Four Horsemen"]["marks"]), CT_RABoss_Mods["Deathknight wing: The Four Horsemen"]["announce"]);
		CT_RABoss_PlaySound(3);

	elseif ( event == "unmeteor" ) then
		CT_RABoss_Mods["Deathknight wing: The Four Horsemen"]["meteortrip"] = false;

	elseif ( event == "unwrath" ) then
		CT_RABoss_Mods["Deathknight wing: The Four Horsemen"]["wrathtrip"] = false;

	end
end