-- Midnight Reveries Naxxramas Boss Mods v7.23 - 21/09/2006
-- Nothing changed.


-- Loading Modules
tinsert(CT_RABoss_ModsToLoad, "CT_RABoss_MRAnub_OnLoad");
tinsert(CT_RABoss_ModsToLoad, "CT_RABoss_MRFaerlina_OnLoad");
tinsert(CT_RABoss_ModsToLoad, "CT_RABoss_MRMaexxna_OnLoad");


-- Anub'Rekhan (23/08/2006) - Changed timers.
function CT_RABoss_MRAnub_OnLoad()
	CT_RABoss_AddMod("Spider wing: Anub'Rekhan", CT_RABOSS_MRANUB_INFO, 1, CT_RABOSS_LOCATIONS_MRNAXXRAMAS);
	CT_RABoss_AddEvent("Spider wing: Anub'Rekhan", "CHAT_MSG_MONSTER_YELL", CT_RABoss_MRAnub_EventHandler);
	CT_RABoss_AddEvent("Spider wing: Anub'Rekhan", "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_BUFF", CT_RABoss_MRAnub_EventHandler);
	CT_RABoss_AddEvent("Spider wing: Anub'Rekhan", "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE", CT_RABoss_MRAnub_EventHandler);

	CT_RABoss_AddDropDownButton("Spider wing: Anub'Rekhan", { CT_RABOSS_ANNOUNCE, CT_RABOSS_ANNOUNCE_INFO .. CT_RABOSS_REQ_LEADER_OR_PROM }, "CT_RABoss_ModInfo", "announce", "CT_RABoss_SetInfo");
end

function CT_RABoss_MRAnub_EventHandler(event)
	if ( not CT_RABoss_Mods["Spider wing: Anub'Rekhan"] or not CT_RABoss_Mods["Spider wing: Anub'Rekhan"]["status"] or not CT_RABoss_Mods["Spider wing: Anub'Rekhan"].enabled ) then
		return;
	end

	if ( event == "CHAT_MSG_MONSTER_YELL" ) then
		if ( arg1 == CT_RABOSS_MRANUB_YELL1 or arg1 == CT_RABOSS_MRANUB_YELL2 or arg1 == CT_RABOSS_MRANUB_YELL3 ) then
			CT_RABoss_Announce(CT_RABOSS_MRANUB_ENGAGE, CT_RABoss_Mods["Spider wing: Anub'Rekhan"]["announce"]);
			CT_RABoss_PlaySound(3);
			CT_RABoss_Schedule("CT_RABoss_MRAnub_EventHandler", 63, "warn30");
			CT_RABoss_Schedule("CT_RABoss_MRAnub_EventHandler", 83, "warn10");

			if ( CT_RA_Level >= 1 and CT_RABoss_Mods["Spider wing: Anub'Rekhan"]["announce"] ) then
				CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "1", "20", CT_RABOSS_MRANUB_LOCUST, "90", "0*255*0"));
			end
		end

	elseif ( event == "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE" or event == "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_BUFF" ) then
		if ( arg1 == CT_RABOSS_MRANUB_CASTSTRING ) then
			CT_RABoss_Announce(CT_RABOSS_MRANUB_CASTWARN, CT_RABoss_Mods["Spider wing: Anub'Rekhan"]["announce"]);
			CT_RABoss_PlaySound(2);
			CT_RABoss_UnSchedule("CT_RABoss_MRAnub_EventHandler");
			CT_RABoss_Schedule("CT_RABoss_MRAnub_EventHandler", 63, "warn30");
			CT_RABoss_Schedule("CT_RABoss_MRAnub_EventHandler", 83, "warn10");
			CT_RABoss_Schedule("CT_RABoss_MRAnub_EventHandler", 23, "locuststop");

			if ( CT_RA_Level >= 1 and CT_RABoss_Mods["Spider wing: Anub'Rekhan"]["announce"] ) then
				CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "1", "20", CT_RABOSS_MRANUB_LOCUST, "93", "0*255*0"));
				CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "2", "23", CT_RABOSS_MRANUB_CASTING, "23", "255*0*0"));
			end
		end

	elseif ( event == "warn30" ) then
		CT_RABoss_Announce(format(CT_RABOSS_MRANUB_WARN, "~30"), CT_RABoss_Mods["Spider wing: Anub'Rekhan"]["announce"]);
		CT_RABoss_PlaySound(3);

	elseif ( event == "warn10" ) then
		CT_RABoss_Announce(format(CT_RABOSS_MRANUB_WARN, "~10"), CT_RABoss_Mods["Spider wing: Anub'Rekhan"]["announce"]);
		CT_RABoss_PlaySound(3);

	elseif ( event == "locuststop" ) then
		CT_RABoss_Announce(CT_RABOSS_MRANUB_ENDED, CT_RABoss_Mods["Spider wing: Anub'Rekhan"]["announce"]);
		CT_RABoss_PlaySound(3);
	end
end


-- Grand Widow Faerlina (11/09/2006) - Added logic check for silencing twice within 30 seconds.
function CT_RABoss_MRFaerlina_OnLoad()
	CT_RABoss_AddMod("Spider wing: Grand Widow Faerlina", CT_RABOSS_MRFAERLINA_INFO, 1, CT_RABOSS_LOCATIONS_MRNAXXRAMAS);
	CT_RABoss_AddEvent("Spider wing: Grand Widow Faerlina", "CHAT_MSG_MONSTER_YELL", CT_RABoss_MRFaerlina_EventHandler);
	CT_RABoss_AddEvent("Spider wing: Grand Widow Faerlina", "CHAT_MSG_SPELL_FRIENDLYPLAYER_BUFF", CT_RABoss_MRFaerlina_EventHandler);
	CT_RABoss_AddEvent("Spider wing: Grand Widow Faerlina", "CHAT_MSG_SPELL_PARTY_BUFF", CT_RABoss_MRFaerlina_EventHandler);
	CT_RABoss_AddEvent("Spider wing: Grand Widow Faerlina", "CHAT_MSG_SPELL_PERIODIC_CREATURE_DAMAGE", CT_RABoss_MRFaerlina_EventHandler);

	CT_RABoss_AddDropDownButton("Spider wing: Grand Widow Faerlina", { CT_RABOSS_ANNOUNCE, CT_RABOSS_ANNOUNCE_INFO .. CT_RABOSS_REQ_LEADER_OR_PROM }, "CT_RABoss_ModInfo", "announce", "CT_RABoss_SetInfo");
end

function CT_RABoss_MRFaerlina_EventHandler(event)
	if ( not CT_RABoss_Mods["Spider wing: Grand Widow Faerlina"] or not CT_RABoss_Mods["Spider wing: Grand Widow Faerlina"]["status"] or not CT_RABoss_Mods["Spider wing: Grand Widow Faerlina"].enabled ) then
		return;
	end

	if ( CT_RABoss_Mods["Spider wing: Grand Widow Faerlina"]["engaged"] and ( not CT_RABoss_Mods["Spider wing: Grand Widow Faerlina"]["lastaction"] or ( time() - CT_RABoss_Mods["Spider wing: Grand Widow Faerlina"]["lastaction"] ) > 120 ) ) then
		CT_RABoss_Mods["Spider wing: Grand Widow Faerlina"]["engaged"] = false;
	end

	if ( event == "CHAT_MSG_MONSTER_YELL" ) then
		if (arg1 == CT_RABOSS_MRFAERLINA_YELL1 or arg1 == CT_RABOSS_MRFAERLINA_YELL2 or arg1 == CT_RABOSS_MRFAERLINA_YELL3 or arg1 == CT_RABOSS_MRFAERLINA_YELL4 ) then
			if ( not CT_RABoss_Mods["Spider wing: Grand Widow Faerlina"]["engaged"] ) then
				CT_RABoss_Announce(CT_RABOSS_MRFAERLINA_ENGAGE, CT_RABoss_Mods["Spider wing: Grand Widow Faerlina"]["announce"]);
				CT_RABoss_PlaySound(3);
				CT_RABoss_Schedule("CT_RABoss_MRFaerlina_EventHandler", 30, "enrage30");
				CT_RABoss_Schedule("CT_RABoss_MRFaerlina_EventHandler", 45, "enrage15");
				CT_RABoss_Schedule("CT_RABoss_MRFaerlina_EventHandler", 55, "enrage5");
				CT_RABoss_Mods["Spider wing: Grand Widow Faerlina"]["engaged"] = true;
				CT_RABoss_Mods["Spider wing: Grand Widow Faerlina"]["enraged"] = false;
				CT_RABoss_Mods["Spider wing: Grand Widow Faerlina"]["silenced"] = false;

				if ( CT_RA_Level >= 1 and CT_RABoss_Mods["Spider wing: Grand Widow Faerlina"]["announce"] ) then
					CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "1", "20", CT_RABOSS_MRFAERLINA_ENRAGE, "60", "255*0*0"));
				end
			else
				CT_RABoss_Announce(CT_RABOSS_MRFAERLINA_ENRAGEWARN, CT_RABoss_Mods["Spider wing: Grand Widow Faerlina"]["announce"]);
				CT_RABoss_PlaySound(1);
				CT_RABoss_UnSchedule("CT_RABoss_MRFaerlina_EventHandler");
				CT_RABoss_Schedule("CT_RABoss_MRFaerlina_EventHandler", 30, "enrage30");
				CT_RABoss_Schedule("CT_RABoss_MRFaerlina_EventHandler", 45, "enrage15");
				CT_RABoss_Schedule("CT_RABoss_MRFaerlina_EventHandler", 55, "enrage5");
				CT_RABoss_Mods["Spider wing: Grand Widow Faerlina"]["enraged"] = true;
				CT_RABoss_Mods["Spider wing: Grand Widow Faerlina"]["silenced"] = false;
				CT_RABoss_Mods["Spider wing: Grand Widow Faerlina"]["enragetimer"] = time();

				if ( CT_RA_Level >= 1 and CT_RABoss_Mods["Spider wing: Grand Widow Faerlina"]["announce"] ) then
					CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "1", "20", CT_RABOSS_MRFAERLINA_ENRAGE, "60", "255*0*0"));
				end
			end
			CT_RABoss_Mods["Spider wing: Grand Widow Faerlina"]["lastaction"] = time();

		elseif ( arg1 == "CT_RABOSS_MRFAERLINA_DEAD" ) then
			CT_RABoss_UnSchedule("CT_RABoss_MRFaerlina_EventHandler");
		end	

	elseif ( event == "CHAT_MSG_SPELL_PERIODIC_CREATURE_DAMAGE" ) then
		if ( arg1 == CT_RABOSS_MRFAERLINA_EMBRACESTRING ) then
			CT_RABoss_Mods["Spider wing: Grand Widow Faerlina"]["engaged"] = true;
			CT_RABoss_Mods["Spider wing: Grand Widow Faerlina"]["lastaction"] = time();

			if ( CT_RA_Level >= 1 and CT_RABoss_Mods["Spider wing: Grand Widow Faerlina"]["announce"] ) then
				CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "2", "30", CT_RABOSS_MRFAERLINA_SILENCE, "30", "0*255*0"));
			end

			if ( CT_RABoss_Mods["Spider wing: Grand Widow Faerlina"]["enraged"] ) then
				CT_RABoss_Announce(format(CT_RABOSS_MRFAERLINA_ENRAGESILENCED, (60-(time() - CT_RABoss_Mods["Spider wing: Grand Widow Faerlina"]["enragetimer"]))), CT_RABoss_Mods["Spider wing: Grand Widow Faerlina"]["announce"]);
				CT_RABoss_PlaySound(3);
				CT_RABoss_Mods["Spider wing: Grand Widow Faerlina"]["enraged"] = false;
			else
				CT_RABoss_Announce(CT_RABOSS_MRFAERLINA_SILENCED, CT_RABoss_Mods["Spider wing: Grand Widow Faerlina"]["announce"]);
				CT_RABoss_PlaySound(3);	
				if ( ( time() - CT_RABoss_Mods["Spider wing: Grand Widow Faerlina"]["enragetimer"] ) >= 30 ) then
					CT_RABoss_UnSchedule("CT_RABoss_MRFaerlina_EventHandler");
					CT_RABoss_Schedule("CT_RABoss_MRFaerlina_EventHandler", 15, "enrage15");
					CT_RABoss_Schedule("CT_RABoss_MRFaerlina_EventHandler", 25, "enrage5");
				
					if ( CT_RA_Level >= 1 and CT_RABoss_Mods["Spider wing: Grand Widow Faerlina"]["announce"] ) then
						CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "1", "30", CT_RABOSS_MRFAERLINA_ENRAGE, "30", "255*0*0"));
					end
				end
			end
		end

	elseif ( event == "enrage30") then
		CT_RABoss_Announce(format(CT_RABOSS_MRFAERLINA_ENRAGEIN, "~30"), CT_RABoss_Mods["Spider wing: Grand Widow Faerlina"]["announce"]);
		CT_RABoss_PlaySound(3);

	elseif ( event == "enrage15") then
		CT_RABoss_Announce(format(CT_RABOSS_MRFAERLINA_ENRAGEIN, "~15"), CT_RABoss_Mods["Spider wing: Grand Widow Faerlina"]["announce"]);
		CT_RABoss_PlaySound(3);

	elseif ( event == "enrage5") then
		CT_RABoss_Announce(format(CT_RABOSS_MRFAERLINA_ENRAGEIN, "~5"), CT_RABoss_Mods["Spider wing: Grand Widow Faerlina"]["announce"]);
		CT_RABoss_PlaySound(3);
	end
end


-- Maexxna (19/08/2006) - Changed naming.
function CT_RABoss_MRMaexxna_OnLoad()
	CT_RABoss_AddMod("Spider wing: Maexxna", CT_RABOSS_MRMAEXXNA_INFO, 1, CT_RABOSS_LOCATIONS_MRNAXXRAMAS);
	CT_RABoss_AddEvent("Spider wing: Maexxna", "CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE", CT_RABoss_MRMaexxna_EventHandler);
	CT_RABoss_AddEvent("Spider wing: Maexxna", "CHAT_MSG_SPELL_PERIODIC_FRIENDLYPLAYER_DAMAGE", CT_RABoss_MRMaexxna_EventHandler);
	CT_RABoss_AddEvent("Spider wing: Maexxna", "CHAT_MSG_SPELL_PERIODIC_PARTY_DAMAGE", CT_RABoss_MRMaexxna_EventHandler);
	CT_RABoss_AddEvent("Spider wing: Maexxna", "CHAT_MSG_MONSTER_EMOTE", CT_RABoss_MRMaexxna_EventHandler);
	CT_RABoss_AddEvent("Spider wing: Maexxna", "CHAT_MSG_ADDON", CT_RABoss_MRMaexxna_EventHandler);
	CT_RABoss_AddEvent("Spider wing: Maexxna", "PLAYER_REGEN_DISABLED", CT_RABoss_MRMaexxna_EventHandler);

	CT_RABoss_AddDropDownButton("Spider wing: Maexxna", { CT_RABOSS_ANNOUNCE, CT_RABOSS_ANNOUNCE_INFO .. CT_RABOSS_REQ_LEADER_OR_PROM }, "CT_RABoss_ModInfo", "announce", "CT_RABoss_SetInfo");
	CT_RABoss_AddDropDownButton("Spider wing: Maexxna", { CT_RABOSS_MRMAEXXNA_WRAP_ALERT, CT_RABOSS_MRMAEXXNA_WRAP_ALERT_INFO }, "CT_RABoss_ModInfo", "wrapenable", "CT_RABoss_MRMaexxna_Togglewraps");
	CT_RABoss_AddDropDownButton("Spider wing: Maexxna", { CT_RABOSS_MRMAEXXNA_WRAP_NAMES, CT_RABOSS_MRMAEXXNA_WRAP_NAMES_INFO }, "CT_RABoss_ModInfo", "wrapnames", "CT_RABoss_MRMaexxna_Togglenames");


	CT_RABoss_SetVar("Spider wing: Maexxna", "wrapenable", 1);
end

function CT_RABoss_MRMaexxna_Togglewraps()
	if ( CT_RABoss_Mods["Spider wing: Maexxna"]["wrapenable"] ) then
		CT_RABoss_SetVar("Spider wing: Maexxna", "wrapenable", false);
		CT_RABoss_SetVar("Spider wing: Maexxna", "wrapnames", false);
		CloseMenus();
	else
		CT_RABoss_SetVar("Spider wing: Maexxna", "wrapenable", true);
	end
end
	
function CT_RABoss_MRMaexxna_Togglenames()
	if ( CT_RABoss_Mods["Spider wing: Maexxna"]["wrapnames"] ) then
		CT_RABoss_SetVar("Spider wing: Maexxna", "wrapnames", false);
	else
		CT_RABoss_SetVar("Spider wing: Maexxna", "wrapnames", true);
		CT_RABoss_SetVar("Spider wing: Maexxna", "wrapenable", true);
		CloseMenus();
	end
end

function CT_RABoss_MRMaexxna_Start()
	CT_RABoss_Announce(CT_RABOSS_MRMAEXXNA_ENGAGE, CT_RABoss_Mods["Spider wing: Maexxna"]["announce"]);
	CT_RABoss_PlaySound(3);	
	CT_RABoss_Mods["Spider wing: Maexxna"]["lastaction"] = time();
	CT_RABoss_Mods["Spider wing: Maexxna"]["engaged"] = true;
	CT_RABoss_Schedule("CT_RABoss_MRMaexxna_EventHandler", 20, "webwarn15");
	CT_RABoss_Schedule("CT_RABoss_MRMaexxna_EventHandler", 25, "webwarn10");
	CT_RABoss_Schedule("CT_RABoss_MRMaexxna_EventHandler", 30, "webwarn5");

	if ( CT_RA_Level >= 1 and CT_RABoss_Mods["Spider wing: Maexxna"]["announce"] ) then
		CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "1", "20", CT_RABOSS_MRMAEXXNA_SPRAY, "35", "255*0*0"));
		CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "2", "20", CT_RABOSS_MRMAEXXNA_SPAWNS, "25", "0*0*255"));
		CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "3", "20", CT_RABOSS_MRMAEXXNA_WRAPS, "15", "0*255*255"));
	end
end

function CT_RABoss_MRMaexxna_EventHandler(event)
	if ( not CT_RABoss_Mods["Spider wing: Maexxna"] or not CT_RABoss_Mods["Spider wing: Maexxna"]["status"] or not CT_RABoss_Mods["Spider wing: Maexxna"].enabled ) then
		return;
	end

	if ( CT_RABoss_Mods["Spider wing: Maexxna"]["engaged"] and ( not CT_RABoss_Mods["Spider wing: Maexxna"]["lastaction"] or ( time() - CT_RABoss_Mods["Spider wing: Maexxna"]["lastaction"] ) > 60 ) ) then
		CT_RABoss_Mods["Spider wing: Maexxna"]["engaged"] = false;
	end

	if ( event == "CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE" or event == "CHAT_MSG_SPELL_PERIODIC_FRIENDLYPLAYER_DAMAGE" or event == "CHAT_MSG_SPELL_PERIODIC_PARTY_DAMAGE" ) then
		if ( string.find(arg1, CT_RABOSS_MRMAEXXNA_SPRAYSTRING) and not CT_RABoss_Mods["Spider wing: Maexxna"]["webtrip"] ) then
			CT_RABoss_Announce(CT_RABOSS_MRMAEXXNA_SPRAYWARN, CT_RABoss_Mods["Spider wing: Maexxna"]["announce"]);
			CT_RABoss_PlaySound(2);
			CT_RABoss_Mods["Spider wing: Maexxna"]["lastaction"] = time();
			CT_RABoss_Mods["Spider wing: Maexxna"]["webtrip"] = true;
			CT_RABoss_UnSchedule("CT_RABoss_MRMaexxna_EventHandler");
			CT_RABoss_Schedule("CT_RABoss_MRMaexxna_EventHandler", 25, "webwarn15");
			CT_RABoss_Schedule("CT_RABoss_MRMaexxna_EventHandler", 30, "webwarn10");
			CT_RABoss_Schedule("CT_RABoss_MRMaexxna_EventHandler", 35, "webwarn5");

			if ( CT_RA_Level >= 1 and CT_RABoss_Mods["Spider wing: Maexxna"]["announce"] ) then
				CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "1", "20", CT_RABOSS_MRMAEXXNA_SPRAY, "40", "255*0*0"));
			end

		elseif ( CT_RABoss_Mods["Spider wing: Maexxna"]["wrapenable"] ) then
			local _, _, playername, playertype = string.find(arg1, CT_RABOSS_MRMAEXXNA_WWEXP);
			if ( playername ) then
				if ( playertype == CT_RABOSS_MRNAME_TYPE_YOU and playername == CT_RABOSS_MRNAME_YOU ) then
					playername = UnitName("player");
					CT_RABoss_Announce(CT_RABOSS_MRMAEXXNA_WRAPPED_YOU);
					CT_RABoss_PlaySound(2);

				elseif ( CT_RABoss_Mods["Spider wing: Maexxna"]["wrapnames"] ) then
					CT_RABoss_Announce(format(CT_RABOSS_MRMAEXXNA_WRAPPED, playername));
				end

				if ( CT_RA_Level >= 1 and CT_RABoss_Mods["Spider wing: Maexxna"]["announce"] ) then
					if ( CT_RABoss_Mods["Spider wing: Maexxna"]["wrapnames"] ) then
						CT_RA_AddMessage("MS " .. format(CT_RABOSS_MRMAEXXNA_WRAPPED, playername));

					elseif ( not CT_RABoss_Mods["Spider wing: Maexxna"]["wraptrip"] ) then
						CT_RABoss_Announce(CT_RABOSS_MRMAEXXNA_WRAPWARN, CT_RABoss_Mods["Spider wing: Maexxna"]["announce"]);
					end

					if ( not CT_RABoss_Mods["Spider wing: Maexxna"]["wraptrip"] ) then
						CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "3", "20", CT_RABOSS_MRMAEXXNA_WRAPS, "40", "0*255*155"));
						CT_RABoss_PlaySound(2);
					end
				end

				CT_RABoss_Mods["Spider wing: Maexxna"]["wraptrip"] = true;
				CT_RABoss_Mods["Spider wing: Maexxna"]["lastaction"] = time();
			end
		end

	elseif ( event == "CHAT_MSG_MONSTER_EMOTE" and arg2 == CT_RABOSS_MRMAEXXNA_BOSSNAME ) then
		if ( arg1 == CT_RABOSS_MRMAEXXNA_ENRAGESTRING ) then
			CT_RABoss_Announce(CT_RABOSS_MRMAEXXNA_ENRAGEWARN, CT_RABoss_Mods["Spider wing: Maexxna"]["announce"]);
			CT_RABoss_PlaySound(1);
			CT_RABoss_Mods["Spider wing: Maexxna"]["lastaction"] = time();
		end
 
	elseif ( event == "PLAYER_REGEN_DISABLED" and not CT_RABoss_Mods["Spider wing: Maexxna"]["engaged"] ) then
		CT_RABoss_Schedule("CT_RABoss_MRMaexxna_EventHandler", 5, "engagecheck");	

	elseif ( event == "CHAT_MSG_ADDON" and arg1 == "CTRA" ) then
		if ( arg2 == "MAEXXNAENGSYNC" and not CT_RABoss_Mods["Spider wing: Maexxna"]["engaged"] ) then
			CT_RABoss_MRMaexxna_Start();
		end

	elseif ( event == "engagecheck" and not CT_RABoss_Mods["Spider wing: Maexxna"]["engaged"] ) then
		if ( UnitName("target") == CT_RABOSS_MRMAEXXNA_BOSSNAME and UnitAffectingCombat("target") ) then
			CT_RABoss_MRMaexxna_Start();
			CT_RA_SendMessage("MAEXXNAENGSYNC");

		elseif ( UnitName("playertarget") == CT_RABOSS_MRMAEXXNA_BOSSNAME and UnitAffectingCombat("playertarget") ) then
			CT_RABoss_MRMaexxna_Start();
			CT_RA_SendMessage("MAEXXNAENGSYNC");
		else
			local i
			for i = 1, GetNumRaidMembers(), 1 do
				if ( UnitName("raid"..i.."target") == CT_RABOSS_MRMAEXXNA_BOSSNAME and UnitAffectingCombat("raid"..i.."target")) then
					CT_RABoss_MRMaexxna_Start();
					CT_RA_SendMessage("MAEXXNAENGSYNC");
					break;
				end
			end
		end

	elseif ( event == "webwarn15" ) then
		CT_RABoss_Announce(CT_RABOSS_MRMAEXXNA_15SEC, CT_RABoss_Mods["Spider wing: Maexxna"]["announce"]);
		CT_RABoss_PlaySound(3);	
		CT_RABoss_Mods["Spider wing: Maexxna"]["webtrip"] = false;
		CT_RABoss_Mods["Spider wing: Maexxna"]["wraptrip"] = false;

	elseif ( event == "webwarn10" ) then
		CT_RABoss_Announce(CT_RABOSS_MRMAEXXNA_10SEC, CT_RABoss_Mods["Spider wing: Maexxna"]["announce"]);
		CT_RABoss_PlaySound(2);

		if ( CT_RA_Level >= 1 and CT_RABoss_Mods["Spider wing: Maexxna"]["announce"] ) then
			CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "2", "20", CT_RABOSS_MRMAEXXNA_SPAWNS, "40", "0*0*255"));
		end

	elseif ( event == "webwarn5" ) then
		CT_RABoss_Announce(CT_RABOSS_MRMAEXXNA_5SEC, CT_RABoss_Mods["Spider wing: Maexxna"]["announce"]);
		CT_RABoss_PlaySound(3);
	end
end